"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var core_1 = require("@material-ui/core");
var form_1 = require("../models/form");
var set_1 = require("../lib/set");
var MuiRhfTextField_1 = __importDefault(require("./MuiRhfTextField"));
var MuiRhfForm = function (_a) {
    var fields = _a.fields, headers = _a.headers, watch = _a.watch, control = _a.control, spacing = _a.spacing;
    return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.Children.toArray(fields.map(function (fieldArray, key) {
        // Format of fieldArray is NOT valid, must be array of array
        if (!Array.isArray(fieldArray)) {
            return null;
        }
        var header = headers === null || headers === void 0 ? void 0 : headers[key];
        return (react_1.default.createElement(core_1.Grid, { container: true, spacing: spacing },
            header && (react_1.default.createElement(core_1.Grid, { item: true, xs: 12 }, header.title && react_1.default.createElement("h2", null, header.title))),
            fieldArray.map(function (_a) {
                var name = _a.name, label = _a.label, _b = _a.props, props = _b === void 0 ? {} : _b, _c = _a.gridProps, gridProps = _c === void 0 ? {} : _c, _d = _a.type, type = _d === void 0 ? "textField" : _d, hideCondition = _a.hideCondition, hideConditions = _a.hideConditions, conditionalProps = _a.conditionalProps;
                // Initialize dynamic props based on watched values
                var extra = {};
                var MuiRhfField = form_1.fieldComponentMap[type] || // Retrieve component depending on type
                    MuiRhfTextField_1.default; //fallback to textField in case not valid type
                if (watch) {
                    // Union will be used in hideCondition keys
                    if (hideCondition) {
                        var conditionHidden_1 = true;
                        // Retrieve hideConditions keys
                        var conditionKeys = Object.keys(hideCondition);
                        // Retrieve watched values
                        var conditionWatchedValues_1 = watch(conditionKeys);
                        // Check hideConditions, we are actually doing an union of hideConditions
                        // If at least one hideCondition has been satisfied, display
                        conditionKeys.forEach(function (conditionKey) {
                            if (hideCondition[conditionKey](conditionWatchedValues_1[conditionKey])) {
                                conditionHidden_1 = false;
                            }
                        });
                        if (conditionHidden_1) {
                            return null;
                        }
                    }
                    // Intersection will be used in hideConditions keys
                    if (hideConditions) {
                        var conditionsHidden_1 = false;
                        // Retrieve hideConditions keys
                        var conditionsKeys = Object.keys(hideConditions);
                        // Retrieve watched values
                        var conditionsWatchedValues_1 = watch(conditionsKeys);
                        // Check hideConditions, we are actually doing an union of hideConditions
                        // All hideCondition needs to be satisfied to display the field
                        conditionsKeys.forEach(function (conditionsKey) {
                            if (!hideConditions[conditionsKey](conditionsWatchedValues_1[conditionsKey])) {
                                conditionsHidden_1 = true;
                            }
                        });
                        if (conditionsHidden_1) {
                            return null;
                        }
                    }
                    if (conditionalProps) {
                        // Retrieve hideConditions keys
                        var conditionalKeys = Object.keys(conditionalProps);
                        // Retrieve watched values
                        var conditionalWatchedValues_1 = watch(conditionalKeys);
                        // Check hideConditions
                        conditionalKeys.forEach(function (conditionalKey) {
                            var _a = conditionalProps[conditionalKey], path = _a[0], customCondition = _a[1];
                            set_1._set(extra, path, customCondition(conditionalWatchedValues_1[conditionalKey]));
                        });
                    }
                }
                return (react_1.default.createElement(core_1.Grid, __assign({ key: name || label, item: true, xs: 4 }, gridProps),
                    react_1.default.createElement(MuiRhfField, __assign({}, props, extra, { label: label, name: name, control: control }))));
            })));
    }))));
};
exports.default = MuiRhfForm;
