import { Control } from "react-hook-form";
import { TextFieldProps, SelectProps, CheckboxProps } from "@material-ui/core";
/** Common fields props */
export declare type MuiRhfFieldProps = {
    control: Control;
    name: string;
    label?: string;
};
/** TextField */
export declare type MuiRhfTextFieldProps = MuiRhfFieldProps & Omit<TextFieldProps, "onChange"> & {
    defaultValue?: unknown;
};
/** Select */
export declare type MuiRhfSelectProps = MuiRhfFieldProps & {
    defaultValue?: unknown;
    selectProps?: SelectProps;
    options: {
        value: string | number | readonly string[] | undefined;
        label: string;
    }[];
};
/** Checkbox */
export declare type MuiRhfCheckboxProps = MuiRhfFieldProps & Omit<CheckboxProps, "defaultValue" | "onChange" | "label"> & {
    defaultValue?: unknown;
};
/** Autocomplete */
export declare type MuiRhfAutocompleteProps = MuiRhfFieldProps & {
    defaultValue?: unknown;
    textFieldProps?: Omit<TextFieldProps, "onChange">;
    autocompleteProps: any;
};
